VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} Farbe_aendern 
   Caption         =   "Farbe von Flchen ndern"
   ClientHeight    =   2820
   ClientLeft      =   36
   ClientTop       =   384
   ClientWidth     =   7656
   OleObjectBlob   =   "Farbe_aendern.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "Farbe_aendern"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function ChooseColor_Dlg Lib "comdlg32.dll" Alias "ChooseColorA" _
(lpcc As CHOOSECOLOR_TYPE) As Long

Private Type CHOOSECOLOR_TYPE
  lStructSize As Long
  hWndOwner As Long
  hInstance As Long
  rgbResult As Long
  lpCustColors As Long
  flags As Long
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

' Anwender kann alle Farben whlen
Private Const CC_ANYCOLOR = &H100
' Nachrichten knnen "abgefangen" werden
Private Const CC_ENABLEHOOK = &H10
' Dialogbox Template
Private Const CC_ENABLETEMPLATE = &H20
' Benutzt Template, ignoriert aber den Template-Namen
Private Const CC_ENABLETEMPLATEHANDLE = &H40
' Vollauswahl aller Farben anzeigen
Private Const CC_FULLOPEN = &H2
' Deaktiviert den Button zum ffnen der Dialogbox-Erweiterung
Private Const CC_PREVENTFULLOPEN = &H4
' Vorgabe einer Standard-Farbe
Private Const CC_RGBINIT = &H1
' Hilfe-Button anzeigen
Private Const CC_SHOWHELP = &H8
' nur Grundfarben auswhlbar
Private Const CC_SOLIDCOLOR = &H80

'Autor der Funktion zum RGB umwandeln: syrex
'http://www.vbfrance.com/codes/COLOR-PICKER-WINDOWS_31170.aspx

Public Function gfnLongToRGBString(lColor As Long) As String
   Dim iRed, iGreen, iBlue As Byte
   iRed = lColor Mod 256
   iGreen = ((lColor And &HFF00) / 256&) Mod 256&
   iBlue = (lColor And &HFF0000) / 65536
   gfnLongToRGBString = str$(iRed) & str$(iGreen) & str$(iBlue)
End Function



Private Sub Alt_Farbe_Click()
    Dim CC_T As CHOOSECOLOR_TYPE, retVal As Long
    Static BDF(16) As Long

   'Einige Farben vordefinieren (Benutzerdefinierte Farben)
   BDF(0) = RGB(255, 0, 255)
   BDF(1) = RGB(125, 125, 125)
   BDF(2) = RGB(90, 90, 90)

   With CC_T
      .lStructSize = Len(CC_T)       'Strukturgre
      .flags = CC_RGBINIT Or CC_ANYCOLOR Or CC_FULLOPEN Or _
        CC_PREVENTFULLOPEN           'Flags
      .rgbResult = RGB(0, 0, 0)      'Farbe voreinstellen
      
      .lpCustColors = VarPtr(BDF(0)) 'Benutzerdefinierte Farben zuweisen
   End With

   retVal = ChooseColor_Dlg(CC_T) 'Dialog anzeigen

   If retVal <> 0 Then
      Me.Farbe_alt.BackColor = CC_T.rgbResult   'gewhlte Farbe als Hintergrund setzen
     
     rgbString = LTrim(RTrim(gfnLongToRGBString(CC_T.rgbResult)))
    
      red = Mid(rgbString, 1, InStr(rgbString, " ") - 1)
      green = Mid(rgbString, Len(red) + 2, InStr(Len(red) + 2, rgbString, " ") - Len(red) - 2)
      blue = Right(rgbString, Len(rgbString) - Len(red) - Len(green) - 2)
            
      Me.RGB1 = red
      Me.RGB2 = green
      Me.RGB3 = blue
      
    Else
      MsgBox "Das Auswhlen einer Farbe ist fehlgeschlagen," & _
      "oder Sie haben Abbrechen gedrckt", vbCritical, "Fehler"
    End If
End Sub

Private Sub Farbe_aendern_Start_Click()

  RGBalt1 = RGB1.Value
  RGBalt2 = RGB2.Value
  RGBalt3 = RGB3.Value
  
sRGB_OLD = RGBalt1 & "," & RGBalt2 & "," & RGBalt3

   
  RGBneu1 = RGB4.Value
  RGBneu2 = RGB5.Value
  RGBneu3 = RGB6.Value
  
SRGB_NEW = RGBneu1 & "," & RGBneu2 & "," & RGBneu3
  
  
  Unload Farbe_aendern

End Sub

Private Sub Farbe_alt_Change()

End Sub

Private Sub Neue_Farbe_Click()
    Dim CC_T As CHOOSECOLOR_TYPE, retVal As Long
    Static BDF2(16) As Long

   'Einige Farben vordefinieren (Benutzerdefinierte Farben)
   BDF2(0) = RGB(255, 0, 255)
   BDF2(1) = RGB(125, 125, 125)
   BDF2(2) = RGB(90, 90, 90)

   With CC_T
      .lStructSize = Len(CC_T)       'Strukturgre
      .flags = CC_RGBINIT Or CC_ANYCOLOR Or CC_FULLOPEN Or _
        CC_PREVENTFULLOPEN           'Flags
      .rgbResult = RGB(0, 0, 0)      'Farbe voreinstellen
      
      .lpCustColors = VarPtr(BDF2(0)) 'Benutzerdefinierte Farben zuweisen
   End With

   retVal = ChooseColor_Dlg(CC_T) 'Dialog anzeigen

   If retVal <> 0 Then
      Me.Farbe_neu.BackColor = CC_T.rgbResult   'gewhlte Farbe als Hintergrund setzen
             
      
     rgbString = LTrim(RTrim(gfnLongToRGBString(CC_T.rgbResult)))
    
      red = Mid(rgbString, 1, InStr(rgbString, " ") - 1)
      green = Mid(rgbString, Len(red) + 2, InStr(Len(red) + 2, rgbString, " ") - Len(red) - 2)
      blue = Right(rgbString, Len(rgbString) - Len(red) - Len(green) - 2)
         
      Me.RGB4 = red
      Me.RGB5 = green
      Me.RGB6 = blue
      
      
    Else
      MsgBox "Das Auswhlen einer Farbe ist fehlgeschlagen," & _
      "oder Sie haben Abbrechen gedrckt", vbCritical, "Fehler"
    End If
End Sub

Private Sub RGB1_Change()

End Sub

Private Sub UserForm_Click()

End Sub
