Attribute VB_Name = "Flaechenfarbe_aendern"
Public RGBalt1 As String
Public RGBalt2 As String
Public RGBalt3 As String

Public RGBneu1 As String
Public RGBneu2 As String
Public RGBneu3 As String
Public sRGB_OLD As String
Public SRGB_NEW As String
  




Sub CATMain()

initFarbe_aendern
    Farbe_aendern.Show

Set oDoc = CATIA.ActiveDocument
Set oProd = oDoc.Product
Set oSelection = oDoc.Selection
Set oVisPropertySet = oSelection.VisProperties
If oSelection.Count <> 1 Then
  MsgBox "Bitte zuerst eine Selektion vornehmen. Abbruch.", 48, "Error"
  Exit Sub
End If

If sRGB_OLD = "" Then
  Exit Sub
Else
  aRGB_Old = FUNC_RGB(sRGB_OLD)
  If IsEmpty(aRGB_Old) Then
      Exit Sub
  End If
End If

If SRGB_NEW = "" Then
  Exit Sub
Else
  aRGB_New = FUNC_RGB(SRGB_NEW)
  If IsEmpty(aRGB_New) Then
      Exit Sub
  End If
End If
oSelection.Search ("Topology.CGMFace,sel")
Dim aSurf()
ReDim aSurf(oSelection.Count)
For i = 1 To oSelection.Count
  Set aSurf(i) = oSelection.Item(i)
Next
oSelection.Clear
Dim R As Long, _
    G As Long, _
    B As Long, _
    iCount As Integer
    iCount = 0
For i = 1 To UBound(aSurf)
  oSelection.Clear
  oSelection.Add (aSurf(i).Reference)
  oVisPropertySet.GetRealColor R, G, B
  If R = CLng(aRGB_Old(0)) And G = CLng(aRGB_Old(1)) And B = CLng(aRGB_Old(2)) Then
      oVisPropertySet.SetRealColor CLng(aRGB_New(0)), CLng(aRGB_New(1)), CLng(aRGB_New(0)), 0

      oVisPropertySet.SetRealOpacity 255, 0

      iCount = iCount + 1
  End If
Next

MsgBox iCount & " Flchen wurden umgefrbt.", 64, "Info"

End Sub


Function FUNC_RGB(sRGB)
  Dim bErr As Boolean
  bErr = True
  aRGB = Split(sRGB, ",")
  If UBound(aRGB) = 2 And bErr Then
      For i = 0 To UBound(aRGB)
        If Not (aRGB(i)) = "" And bErr Then
            If Not IsNumeric(aRGB(i)) Or Int(aRGB(i)) < 0 Or Int(aRGB(i)) > 255 Or Not bErr Then
              bErr = False
            End If
        Else
            bErr = False
        End If
      Next
  Else
      bErr = False
  End If
  If Not bErr Then
      MsgBox "Falsche Eingabe. Abbruch.", 48, "Error"
      Exit Function
  Else
      FUNC_RGB = aRGB
  End If
End Function
Sub initFarbe_aendern()

End Sub



